#ifndef lint
static const char rcsid[] = "$Id: test3.c,v 1.1.1.1 1996/06/30 15:50:54 mtp Exp $";
#endif
/****************************************************************************
 *    
 *  COPYRIGHT NOTICE
 *    
 *  Copyright (C) 1995, 1996 Michael T. Peterson
 *  This file is part of the PCthreads (tm) multithreading library
 *  package.
 *    
 *  The source files and libraries constituting the PCthreads (tm) package
 *  are free software; you can redistribute them and/or modify them under
 *  the terms of the GNU Library General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *    
 *  The PCthreads (tm) package is distributed in the hope that it will
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *    
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library (see the file COPYING.LIB); if not,
 *  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 *  MA 02139, USA.
 *    
 *  To report bugs, bug fixes, or provide feedback you may contact the
 *  author, Michael T. Peterson, at either of the two email addresses listed
 *  below:
 *    
 *             mtp@big.aa.net (preferred)
 *             mtp@zso.dec.com
 *    
 *    
 *  Michael T. Peterson
 *  Issaquah, WA
 *  29 January, 1996
 ****************************************************************************
 * $Log: test3.c,v $
 * Revision 1.1.1.1  1996/06/30 15:50:54  mtp
 * DCE threads for Linux V1.0
 *
 ****************************************************************************
 */
#include <pthread.h>
#include <stdio.h>
#include <utils.h>

extern int getpid( void );

void
ctrl_c_handler( int sig )
{
	printf("^C interrupt.");
	pthread_kill( NULL, SIGKILL );
}

void
term_handler( int sig )
{
	pthread_lock_global_np();
	printf("Caught %d %s in handler!\n", sig, sys_signame[sig] );
	pthread_unlock_global_np();
}

void
catcher( void )
{
	struct timespec ts = { 0, 50000 };

	while( 1 )
	{
		printf("catcher");
		pthread_delay_np( &ts );
	}

	pthread_exit( (void *) 0 );
}


int main( int argc, char *argv[] )
{
   pthread_t th;
   struct sigaction act;
   struct timespec ts = { 0, 100000 };

   act.sa_handler = term_handler;
   sigemptyset( &act.sa_mask );
   pthread_sigaction_np( SIGTERM, &act, NULL );

   act.sa_handler = ctrl_c_handler;
   sigemptyset( &act.sa_mask );
   pthread_sigaction_np( SIGINT, &act, NULL );

   pthread_create( &th, NULL, (thread_proc_t) catcher, NULL );

   /*
    * Sleep for 0.5 seconds, wake-up, and send a signal to the
	* catcher thread.  Do this until the process takes a kill -9.
    */
   while( 1 )
   {
	   pthread_delay_np( &ts );
	   pthread_kill( th, SIGTERM );
   }

   return(0);
}
